import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class CategoriaEntity extends Equatable {
  final String uuid;
  final String nombre;

  CategoriaEntity(this.uuid, this.nombre);

  Map<String, Object> toJson(){
    return{
      'nombre': this.nombre
    };

  }

  @override
  String toString() {
    return 'CategoriaEntity{uuid: $uuid, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is CategoriaEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      nombre.hashCode;

  CategoriaEntity.fromJson(Map<String, dynamic> json)
    : uuid = json['uuid'],
      nombre = json['nombre'];

  CategoriaEntity.fromSnapshot(DocumentSnapshot snapshot)
      : uuid = snapshot.documentID,
        nombre = snapshot.data['nombre'];

  Map<String, Object> toDocument(){
    return {
      'nombre': this.nombre,
    };
  }


}