import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class CategoriaSanitariaEntity extends Equatable{
  final String uuid;
  final String nombre;

  CategoriaSanitariaEntity(this.uuid, this.nombre);

  Map<String, Object> toJson() {
    return{
      'nombre': this.nombre
    };
  }

  @override
  String toString() {
    return 'CategoriaSanitariaEntity{uuid: $uuid, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is CategoriaSanitariaEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      nombre.hashCode;

  static CategoriaSanitariaEntity fromJson(Map<String, Object> json){
    return CategoriaSanitariaEntity(
      json['uuid'] as String,
      json['nombre'] as String
    );
  }

  static CategoriaSanitariaEntity fromSnapshot(DocumentSnapshot snapshot){
    return CategoriaSanitariaEntity(
      snapshot.documentID,
      snapshot.data['nombre']
    );
  }

  Map<String, Object> toDocument(){
    return{
      'nombre': nombre
    };
  }

}