import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class CorralEntity extends Equatable {
  final String uuid;
  final String nombre;
  final bool activo;

  CorralEntity(this.uuid, this.nombre, this.activo);

  Map<String, Object> toJson() {
    return {
      'nombre': this.nombre,
      'fecha': this.activo,
    };
  }

  @override
  String toString() {
    return 'CorralEntity{uuid: $uuid, nombre: $nombre, activo: $activo}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is CorralEntity &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          nombre == other.nombre &&
          activo == other.activo;

  @override
  int get hashCode =>
      super.hashCode ^ uuid.hashCode ^ nombre.hashCode ^ activo.hashCode;

  static CorralEntity fromJson(Map<String, Object> json) {
    return CorralEntity(json["uuid"] as String, json["nombre"] as String,
        json["activo"] as bool);
  }

  CorralEntity.fromSnapshot(DocumentSnapshot snapshot)
      : uuid = snapshot.documentID,
        nombre = snapshot.data['nombre'],
        activo = snapshot.data['activo'];

  Map<String, Object> toDocument(){
    return {
      "nombre": nombre,
      "activo": activo,
    };
  }

}


