import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class DietaProgramadaEntity extends Equatable {
  final String uuid;
  final String dieta;
  final DateTime fecha;
  final String tropa;

  DietaProgramadaEntity(this.uuid, this.dieta, this.fecha, this.tropa);

  Map<String, Object> toJson() {
    return {
      'uuid': this.uuid,
      'dieta': this.dieta,
      'fecha': this.fecha,
      'tropa': this.tropa
    };
  }

  @override
  String toString() {
    return 'DietaProgramadaEntity{uuid: $uuid, dieta: $dieta, fecha: $fecha, tropa: $tropa}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is DietaProgramadaEntity &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          dieta == other.dieta &&
          fecha == other.fecha &&
          tropa == other.tropa;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      dieta.hashCode ^
      fecha.hashCode ^
      tropa.hashCode;

  static DietaProgramadaEntity fromJson(Map<String, Object> json) {
    return DietaProgramadaEntity(
        json['uuid'] as String,
        json['dieta'] as String,
        json['fecha'] as DateTime,
        json['tropa'] as String);
  }

  static DietaProgramadaEntity fromSnapshot(DocumentSnapshot snap) {
    return DietaProgramadaEntity(snap.documentID, snap.data['dieta'],
        snap.data['fecha'].toDate(), snap.data['rodeo']);
  }

  Map<String, Object> toDocument() {
    return {'dieta': this.dieta, 'fecha': this.fecha, 'rodeo': this.tropa};
  }
}
