import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class DispositivoEntity extends Equatable {
  final String uuid;
  final String profileUuid;
  final String baston;
  final String monitor;

  DispositivoEntity(this.uuid, this.profileUuid, this.baston, this.monitor);

  Map<String, Object> toJson() {
    return {
      'profileUuid': this.profileUuid,
      'baston': this.baston,
      'monitor': this.monitor
    };
  }

  @override
  String toString() {
    return 'DispositivoEntity{profileUuid: $profileUuid baston: $baston, monitor: $monitor}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      super == other &&
          other is DispositivoEntity &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          profileUuid == other.profileUuid &&
          baston == other.baston &&
          monitor == other.monitor;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      profileUuid.hashCode ^
      baston.hashCode ^
      monitor.hashCode;

  static DispositivoEntity fromJson(Map<String, Object> json) {
    return DispositivoEntity(
        json['uuid'] as String,
        json['profileUuid'] as String,
        json['baston'] as String,
        json['monitor'] as String);
  }

  static DispositivoEntity fromSnapshot(DocumentSnapshot snap) {
    return DispositivoEntity(
      snap.documentID,
        snap.data['profileUuid'], snap.data['baston'], snap.data['monitor']);
  }

  Map<String, Object> toDocument() {
    return {"profileUuid": profileUuid, "baston": baston, "monitor": monitor};
  }
}
