import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class MixerEntity extends Equatable{
  final String uuid;
  final bool activo;
  final String nombre;

  MixerEntity(this.uuid, this.activo, this.nombre);

  Map<String, Object> toJson(){
    return {
      'activo': this.activo,
      'nombre': this.nombre
    };
  }

  @override
  String toString() {
    return 'MixerEntity{uuid: $uuid, activo: $activo, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is MixerEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              activo == other.activo &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      activo.hashCode ^
      nombre.hashCode;


  static MixerEntity fromJson(Map<String, Object> json){
    return MixerEntity(
      json['uuid'] as String,
      json['activo'] as bool,
      json['nombre'] as String
    );
  }

  static MixerEntity fromSnapshot(DocumentSnapshot snap){
    return MixerEntity(
      snap.documentID,
      snap['activo'],
      snap['nombre']
    );
  }

  Map<String, Object> toDocument(){
    return {
      'activo': this.activo,
      'nombre': this.nombre
    };
  }

}