import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class ProfileEntity extends Equatable {
  String uuid;
  String nombre;
  String apellido;
  bool activo;
  String email;
  String empresa;
  String mixer;
  String rol;
  bool suspended;

  ProfileEntity(
      this.uuid,
      this.nombre,
      this.apellido,
      this.activo,
      this.email,
      this.empresa,
      this.mixer,
      this.rol,
      this.suspended,
);

  Map<String, Object> toJson() {
    return {
      'nombre': this.nombre,
      'apellido': this.apellido,
      'activo': this.activo,
      'email': this.email,
      'empresa': this.empresa,
      'mixer': this.mixer,
      'rol': this.rol,
      'suspended': this.suspended,

    };
  }

  @override
  String toString() {
    return 'ProfileEntity{uuid: $uuid, nombre: $nombre, apellido: $apellido, activo: $activo, email: $email, empresa: $empresa, mixer: $mixer, rol: $rol, suspended: $suspended}';
  }

  static ProfileEntity fromJson(Map<String, Object> json) {
    return ProfileEntity(
        json["uuid"] as String,
        json["nombre"] as String,
        json["apellido"] as String,
        json["activo"] as bool,
        json["email"] as String,
        json["empresa"] as String,
        json["mixer"] as String,
        json["rol"] as String,
        json["suspended"] as bool);
  }

  static ProfileEntity fromSnapshot(DocumentSnapshot snap) {
    return ProfileEntity(
      snap.documentID,
      snap.data['nombre'],
      snap.data['apellido'],
      snap.data['activo'],
      snap.data['email'],
      snap.data['empresa'],
      snap.data['mixer'],
      snap.data['rol'],
      snap.data['suspended'],
    );
  }

  Map<String, Object> toDocument() {
    return {
      "nombre": nombre,
      "apellido": apellido,
      "activo": activo,
      "email": email,
      "email": email,
      "empresa": empresa,
      "mixer": mixer,
      "rol": rol,
      "suspender": suspended,
    };
  }
}
