import 'package:equatable/equatable.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

class RazaEntity extends Equatable {
  final String uuid;
  final String nombre;

  RazaEntity(this.uuid, this.nombre);

  Map<String, Object> toJson() {
    return {'uuid': this.uuid, 'nombre': this.nombre};
  }

  Map<String, dynamic> toMap() {
    return {'uuid': this.uuid, 'nombre': this.nombre};
  }

  RazaEntity.fromMap(Map<dynamic, dynamic> data)
    : uuid = data['uuid'],
      nombre = data['nombre'];

  @override
  String toString() {
    return 'RazaEntity{uuid: $uuid, nombre: $nombre}';
  }

  RazaEntity.fromJson(Map<String, dynamic> data)
    : uuid = data['uuid'],
      nombre = data['nombre'];

  RazaEntity.fromSnapshot(DocumentSnapshot snapshot)
    : uuid = snapshot.documentID,
      nombre = snapshot.data['nombre'];

  Map<String, Object> toDocument(){
    return{
      'nombre': this.nombre
    };
  }


}
