import 'dart:core';

import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:equatable/equatable.dart';

class TerceroEntity extends Equatable{
  final String uuid;
  final String contacto;
  final String nombre;
  final String cuig;
  final bool activo;
  final List<dynamic> campos;

  TerceroEntity(this.uuid, this.contacto, this.nombre, this.cuig, this.activo,
      this.campos);

  @override
  String toString() {
    return 'TerceroEntity{uuid: $uuid, contacto: $contacto, nombre: $nombre, cuig: $cuig, activo: $activo, campos: $campos}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          super == other &&
              other is TerceroEntity &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              contacto == other.contacto &&
              nombre == other.nombre &&
              cuig == other.cuig &&
              activo == other.activo &&
              campos == other.campos;

  @override
  int get hashCode =>
      super.hashCode ^
      uuid.hashCode ^
      contacto.hashCode ^
      nombre.hashCode ^
      cuig.hashCode ^
      activo.hashCode ^
      campos.hashCode;

  Map<String, Object> toJson(){
    return {
      'contacto': this.contacto,
      'nombre': this.nombre,
      'cuig': this.cuig,
      'activo': this.activo,
      'campos': this.campos,
    };
  }

  TerceroEntity.fromJson(Map<String, Object> json)
    : uuid = json['uuid'],
      contacto = json['contacto'],
      nombre = json['nombre'],
      cuig = json['cuig'],
      activo = json['activo'],
      campos = json['campos'];

  TerceroEntity.fromSnapshot(DocumentSnapshot snapshot)
  : uuid = snapshot.documentID,
    contacto = snapshot.data['contacto'],
    nombre = snapshot.data['nombre'],
    cuig = snapshot.data['cuig'],
    activo = snapshot.data['activo'],
    campos = snapshot.data['campos'];

  Map<String, Object> toDocument(){
    return {
      'contacto': this.contacto,
      'nombre': this.nombre,
      'cuig': this.cuig,
      'activo': this.activo,
      'campos': this.campos
    };
  }


}



