import 'dart:async';

import 'package:firebase_repository/src/automatismos_programados_repository.dart';
import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import '../firebase_repository.dart';
import 'dietas_programadas_repository.dart';
import 'entities/entities.dart';

class FirebaseAutomatismosProgramadosRepository implements AutomatismosProgramadosRepository {
  CollectionReference automatismosProgramadosCollection;
  String empresaId;

  FirebaseAutomatismosProgramadosRepository(
      {@required String empresaId}) {
    this.automatismosProgramadosCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection("automatismos_programados");
  }

  @override
  Future<void> addNewAutomatismoProgramado(AutomatismoProgramado automatismoProgramado) {
    return automatismosProgramadosCollection.add(automatismoProgramado.toEntity().toDocument());
  }

  @override
  Future<void> deleteAutomatismoProgramado(AutomatismoProgramado automatismoProgramado) async {
    return automatismosProgramadosCollection.document(automatismoProgramado.uuid).delete();
  }

  @override
  Stream<List<AutomatismoProgramado>> automatismosProgramados() {
    return automatismosProgramadosCollection.snapshots().map((snapshot) {
      print(snapshot);
      return snapshot.documents
          .map((doc) => AutomatismoProgramado.fromEntity(AutomatismoProgramadoEntity.fromSnapshot(doc))).toList();
    });
  }

  @override
  Future<void> updateAutomatismoProgramado(AutomatismoProgramado update) {
    return automatismosProgramadosCollection
        .document(update.uuid)
        .updateData(update.toEntity().toDocument());
  }


}
