import 'dart:async';

import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import '../firebase_repository.dart';
import 'caravana_repository.dart';
import 'entities/entities.dart';

class FirebaseCaravanasRepository implements CaravanasRepository {
  CollectionReference caravanasCollection;
  String empresaId;

  FirebaseCaravanasRepository({@required String empresaId}) {
    this.caravanasCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection("caravanas");
  }

  @override
  Future<void> addNewCaravana(Caravana caravana) {
    return caravanasCollection.add(caravana.toEntity().toDocument());
  }

  @override
  Future<void> deleteCaravana(Caravana caravana) async {
    return caravanasCollection.document(caravana.uuid).delete();
  }

  @override
  Stream<List<Caravana>> caravanas() {
    return caravanasCollection.snapshots().map((snapshot) {
//      return snapshot.documents.map((doc) {
//        if (doc.data['estado'] == "corral" || doc.data['estado'] == "campo")
//          return Caravana.fromEntity(CaravanaEntity.fromSnapshot(doc));
//      }).toList();
      print(snapshot);
      return snapshot.documents
          .map((car) => Caravana.fromEntity(CaravanaEntity.fromSnapshot(car))).toList();
    });
  }

  @override
  Future<void> updateCaravana(Caravana update) {
    return caravanasCollection
        .document(update.uuid)
        .updateData(update.toEntity().toDocument());
  }
}
