import 'dart:async';

import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

import '../firebase_repository.dart';
import 'entities/entities.dart';

class FirebaseEmpresaRepository implements EmpresaRepository {
  DocumentReference documentReference;

  FirebaseEmpresaRepository({@required String empresaId}) {
    this.documentReference =
        Firestore.instance.collection('empresas').document(empresaId);
  }

  @override
  Stream<Empresa> empresa() {
    return documentReference.snapshots().map((doc) {
      return Empresa.fromEntity(EmpresaEntity.fromSnapshot(doc));
    });
  }
}
