import 'dart:async';

import 'package:firebase_repository/src/productos_sanitarios_repository.dart';
import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import '../firebase_repository.dart';
import 'entities/entities.dart';

class FirebaseProductosSanitariosRepository implements ProductosSanitariosRepository {
  CollectionReference productoSanitarioCollection;
  String empresaId;

  FirebaseProductosSanitariosRepository(
      {@required String empresaId}) {
    this.productoSanitarioCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection("productossanitarios");
  }

  @override
  Future<void> addNewProductoSanitario(ProductoSanitario productoSanitario) {
    return productoSanitarioCollection.add(productoSanitario.toEntity().toDocument());
  }

  @override
  Future<void> deleteProductoSanitario(ProductoSanitario productoSanitario) async {
    return productoSanitarioCollection.document(productoSanitario.uuid).delete();
  }

  @override
  Stream<List<ProductoSanitario>> productosSanitarios() {
    return productoSanitarioCollection
        .where("activo", isEqualTo: true).snapshots().map((snapshot) {
      print(snapshot);
      return snapshot.documents
          .map((doc) => ProductoSanitario.fromEntity(ProductoSanitarioEntity.fromSnapshot(doc))).toList();
    });
  }

  @override
  Future<void> updateProductoSanitario(ProductoSanitario update) {
    return productoSanitarioCollection
        .document(update.uuid)
        .updateData(update.toEntity().toDocument());
  }


}
