import 'dart:async';

import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';

import '../firebase_repository.dart';
import 'entities/entities.dart';

class FirebaseProfileRepository implements ProfileRepository {
  DocumentReference documentReference;

  FirebaseProfileRepository({@required String usuarioId}) {
    this.documentReference =
        Firestore.instance.collection('usuarios').document(usuarioId);
  }

  @override
  Stream<Profile> profile() {
    return documentReference.snapshots().map((doc) {
      return Profile.fromEntity(ProfileEntity.fromSnapshot(doc));
    });
  }

  @override
  Future<void> updateProfile(Profile update) {
    return documentReference.updateData(update.toEntity().toDocument());
  }
}
