import 'dart:async';

import 'package:meta/meta.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import '../firebase_repository.dart';
import 'raza_repository.dart';
import 'entities/entities.dart';
import 'raza_repository.dart';

class FirebaseRazasRepository implements RazasRepository {
  CollectionReference razasCollection;
  String empresaId;

  FirebaseRazasRepository({@required String empresaId}) {
    this.razasCollection = Firestore.instance
        .collection('empresas')
        .document(empresaId)
        .collection("razas");
  }

  @override
  Future<void> addNewRaza(Raza raza) {
    return razasCollection.add(raza.toEntity().toDocument());
  }

  @override
  Future<void> deleteRaza(Raza raza) async {
    return razasCollection.document(raza.uuid).delete();
  }

  @override
  Stream<List<Raza>> razas() {
    return razasCollection.snapshots().map((snapshot) {
//      return snapshot.documents.map((doc) {
//        if (doc.data['estado'] == "corral" || doc.data['estado'] == "campo")
//          return Raza.fromEntity(RazaEntity.fromSnapshot(doc));
//      }).toList();
      print(snapshot);
      return snapshot.documents
          .map((raz) => Raza.fromEntity(RazaEntity.fromSnapshot(raz))).toList();
    });
  }

  @override
  Future<void> updateRaza(Raza update) {
    return razasCollection
        .document(update.uuid)
        .updateData(update.toEntity().toDocument());
  }
}
