import 'package:firebase_repository/src/entities/automatismo_programado_entity.dart';
import 'package:firebase_repository/src/entities/dieta_programada_entity.dart';
import 'package:flutter/foundation.dart';
import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class AutomatismoProgramado {
  final String uuid;
  final String dieta;
  final DateTime fecha;
  final double incremento;
  final double decremento;


  AutomatismoProgramado({this.uuid, this.dieta, this.fecha, this.incremento,
      this.decremento});

  AutomatismoProgramado copyWith({String uuid, String dieta, DateTime fecha, double incremento, double decremento}) {
    return AutomatismoProgramado(
      uuid: uuid ?? this.uuid,
      dieta: dieta ?? this.dieta,
      fecha: fecha ?? this.fecha,
      incremento: incremento ?? this.incremento,
      decremento: decremento ?? this.decremento,
    );
  }


  @override
  String toString() {
    return 'AutomatismoProgramado{uuid: $uuid, dieta: $dieta, fecha: $fecha, incremento: $incremento, decremento: $decremento}';
  }


  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is AutomatismoProgramado &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              dieta == other.dieta &&
              fecha == other.fecha &&
              incremento == other.incremento &&
              decremento == other.decremento;

  @override
  int get hashCode =>
      uuid.hashCode ^
      dieta.hashCode ^
      fecha.hashCode ^
      incremento.hashCode ^
      decremento.hashCode;

  AutomatismoProgramadoEntity toEntity() {
    return AutomatismoProgramadoEntity(uuid ,dieta, fecha, incremento, decremento);
  }

  static AutomatismoProgramado fromEntity(AutomatismoProgramadoEntity entity) {
    return AutomatismoProgramado(
        uuid: entity.uuid,
        dieta: entity.dieta, fecha: entity.fecha, incremento: entity.incremento, decremento: entity.decremento);
  }
}
