import 'package:firebase_repository/src/entities/categoria_entity.dart';
import 'package:firebase_repository/src/entities/entities.dart';
import 'package:meta/meta.dart';

@immutable
class Categoria {
  final String uuid;
  final String nombre;

  Categoria({this.uuid, this.nombre});

  Categoria copyWith({String uuid, String nombre}) {
    return Categoria(uuid: uuid ?? this.uuid, nombre: nombre ?? this.nombre);
  }

  @override
  String toString() {
    return 'Categoria{uuid: $uuid, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Categoria &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          nombre == other.nombre;

  @override
  int get hashCode => uuid.hashCode ^ nombre.hashCode;

  CategoriaEntity toEntity() {
    return CategoriaEntity(uuid, nombre);
  }

  static Categoria fromEntity(CategoriaEntity entity) {
    return Categoria(uuid: entity.uuid, nombre: entity.nombre);
  }
}
