import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class CategoriaSanitaria{
  final String uuid;
  final String nombre;

  CategoriaSanitaria({this.uuid, this.nombre});

  CategoriaSanitaria copyWith({String uuid, String nombre}){
    return CategoriaSanitaria(
      uuid: uuid ?? this.uuid,
      nombre: nombre ?? this.nombre
    );
  }

  @override
  String toString() {
    return 'CategoriaSanitaria{uuid: $uuid, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is CategoriaSanitaria &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      uuid.hashCode ^
      nombre.hashCode;

  CategoriaSanitariaEntity toEntity(){
    return CategoriaSanitariaEntity(uuid, nombre);
  }

  static CategoriaSanitaria fromEntity(CategoriaSanitariaEntity entity){
    return CategoriaSanitaria(
      uuid: entity.uuid,
      nombre: entity.nombre
    );
  }

}