import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class Corral {
  final String uuid;
  final String nombre;
  final bool activo;

  Corral({this.uuid, this.nombre, this.activo});

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Corral &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          nombre == other.nombre &&
          activo == other.activo;

  @override
  int get hashCode => uuid.hashCode ^ nombre.hashCode ^ activo.hashCode;

  @override
  String toString() {
    return 'Corral{uuid: $uuid, nombre: $nombre, activo: $activo}';
  }

  Corral copyWith({String uuid, String nombre, bool activo}) {
    return Corral(uuid: uuid ?? this.uuid, nombre: nombre ?? this.nombre);
  }

  CorralEntity toEntity() {
    return CorralEntity(uuid, nombre, activo);
  }

  static Corral fromEntity(CorralEntity entity) {
    return Corral(
      uuid: entity.uuid,
      nombre: entity.nombre,
      activo: entity.activo
    );
  }
}
