import 'package:firebase_repository/src/entities/dieta_programada_entity.dart';
import 'package:flutter/foundation.dart';
import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class DietaProgramada {
  final String uuid;
  final String dieta;
  final DateTime fecha;
  final String tropa;


  DietaProgramada({this.uuid, this.dieta, this.fecha, this.tropa});

  DietaProgramada copyWith({String uuid, String dieta, DateTime fecha, String tropa}) {
    return DietaProgramada(
      uuid: uuid ?? this.uuid,
      dieta: dieta ?? this.dieta,
      fecha: fecha ?? this.fecha,
      tropa: tropa ?? this.tropa,
    );
  }


  @override
  String toString() {
    return 'DietaProgramada{uuid: $uuid, dieta: $dieta, fecha: $fecha, tropa: $tropa}';
  }


  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is DietaProgramada &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              dieta == other.dieta &&
              fecha == other.fecha &&
              tropa == other.tropa;

  @override
  int get hashCode =>
      uuid.hashCode ^
      dieta.hashCode ^
      fecha.hashCode ^
      tropa.hashCode;

  DietaProgramadaEntity toEntity() {
    return DietaProgramadaEntity(uuid ,dieta, fecha, tropa);
  }

  static DietaProgramada fromEntity(DietaProgramadaEntity entity) {
    return DietaProgramada(
        uuid: entity.uuid,
        dieta: entity.dieta, fecha: entity.fecha, tropa: entity.tropa);
  }
}
