import 'package:firebase_repository/src/entities/entities.dart';
import 'package:meta/meta.dart';

@immutable
class Dispositivo {
  final String uuid;
  final String profileUuid;
  final String baston;
  final String monitor;

  Dispositivo({this.uuid, this.profileUuid, this.baston, this.monitor});


  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Dispositivo &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              profileUuid == other.profileUuid &&
              baston == other.baston &&
              monitor == other.monitor;

  @override
  int get hashCode =>
      uuid.hashCode ^
      profileUuid.hashCode ^
      baston.hashCode ^
      monitor.hashCode;

  @override
  String toString() {
    return 'Dispositivo{profileUuid: $profileUuid, baston: $baston, monitor: $monitor}';
  }

  Dispositivo copyWith({String uuid,String profileUuid, String baston, String monitor}) {
    return Dispositivo(
        uuid: uuid ?? this.uuid,
        profileUuid: profileUuid ?? this.profileUuid,
        baston: baston ?? this.baston,
        monitor: monitor ?? this.monitor);
  }

  DispositivoEntity toEntity(){
    return DispositivoEntity(uuid ,profileUuid, baston, monitor);
  }

  static Dispositivo fromEntity(DispositivoEntity entity){
    return Dispositivo(
      uuid: entity.uuid,
      profileUuid: entity.profileUuid,
      baston: entity.baston,
      monitor: entity.monitor
    );
  }

}
