import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class Mixer{
  final String uuid;
  final bool activo;
  final String nombre;

  Mixer({this.uuid, this.activo, this.nombre});

  Mixer copyWith({String uuid, bool activo, String nombre}){
  return Mixer(
    uuid: uuid ?? this.uuid,
    activo: activo ?? this.activo,
    nombre: nombre ?? this.nombre
  );
}

  @override
  String toString() {
    return 'Mixer{uuid: $uuid, activo: $activo, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Mixer &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              activo == other.activo &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      uuid.hashCode ^
      activo.hashCode ^
      nombre.hashCode;

  MixerEntity toEntity(){
    return MixerEntity(uuid, activo, nombre);
  }

  static Mixer fromEntity(MixerEntity entity){
    return Mixer(
      uuid: entity.uuid,
      activo: entity.activo,
      nombre: entity.nombre
    );
  }



}