import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class Pendiente {
  final String uuid;
  final DateTime fecha;
  final bool activo;
  final String usuarioUid;
  final String tipo;
  final int puertas;
  final List<dynamic> caravanasPendientes;
  final String tropaCaravaneo;

  Pendiente(
      {this.uuid,
      this.fecha,
      this.activo,
      this.tipo,
      this.puertas,
      this.caravanasPendientes,
      this.usuarioUid,
      this.tropaCaravaneo});

  Pendiente copyWith(
      {String uuid,
      DateTime fecha,
      bool activo,
      String usuarioUid,
      String tipo,
      int puertas,
      List<dynamic> caravanasPendientes,
      String tropaCaravaneo
      }) {
    return Pendiente(
      uuid: uuid ?? this.uuid,
      fecha: fecha ?? this.fecha,
      activo: activo ?? this.activo,
      usuarioUid: usuarioUid ?? this.usuarioUid,
      tipo: tipo ?? this.tipo,
      puertas: puertas ?? this.puertas,
      caravanasPendientes: caravanasPendientes ?? this.caravanasPendientes,
      tropaCaravaneo: tropaCaravaneo ?? this.tropaCaravaneo
    );
  }


  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Pendiente &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              fecha == other.fecha &&
              activo == other.activo &&
              usuarioUid == other.usuarioUid &&
              tipo == other.tipo &&
              puertas == other.puertas &&
              caravanasPendientes == other.caravanasPendientes &&
              tropaCaravaneo == other.tropaCaravaneo;

  @override
  int get hashCode =>
      uuid.hashCode ^
      fecha.hashCode ^
      activo.hashCode ^
      usuarioUid.hashCode ^
      tipo.hashCode ^
      puertas.hashCode ^
      caravanasPendientes.hashCode ^
      tropaCaravaneo.hashCode;


  @override
  String toString() {
    return 'Pendiente{uuid: $uuid, fecha: $fecha, activo: $activo, usuarioUid: $usuarioUid, tipo: $tipo, puertas: $puertas, caravanasPendientes: $caravanasPendientes, tropaCaravaneo: $tropaCaravaneo}';
  }

  PendienteEntity toEntity() {
    return PendienteEntity(
        uuid, fecha, activo, tipo, puertas, caravanasPendientes, usuarioUid, tropaCaravaneo);
  }

  static Pendiente fromEntity(PendienteEntity entity) {
    return Pendiente(
        uuid: entity.uuid,
        fecha: entity.fecha,
        activo: entity.activo,
        usuarioUid: entity.usuarioUid,
        tipo: entity.tipo,
        puertas: entity.puertas,
        caravanasPendientes: entity.caravanasPendientes,
        tropaCaravaneo: entity.tropaCaravaneo
    );
  }
}
