import 'package:meta/meta.dart';
import '../entities/entities.dart';

@immutable
class ProductoSanitario {
  final String uuid;
  final bool activo;
  final String categoriaUid;
  final double costo;
  final String medida;
  final String nombre;

  ProductoSanitario(
      {this.uuid,
      this.activo,
      this.categoriaUid,
      this.costo,
      this.medida,
      this.nombre});

  ProductoSanitario copyWith(
      {String uuid,
      bool activo,
      String categoriaUid,
      double costo,
      String medida,
      String nombre}) {
    return ProductoSanitario(
      uuid: uuid ?? this.uuid,
      nombre: nombre ?? this.nombre,
      activo: activo ?? this.activo,
      costo: costo ?? this.costo,
      categoriaUid: categoriaUid ?? this.categoriaUid,
      medida: medida ?? this.medida
    );
  }

  @override
  String toString() {
    return 'ProductoSanitario{uuid: $uuid, activo: $activo, categoriaUid: $categoriaUid, costo: $costo, medida: $medida, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is ProductoSanitario &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              activo == other.activo &&
              categoriaUid == other.categoriaUid &&
              costo == other.costo &&
              medida == other.medida &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      uuid.hashCode ^
      activo.hashCode ^
      categoriaUid.hashCode ^
      costo.hashCode ^
      medida.hashCode ^
      nombre.hashCode;

  ProductoSanitarioEntity toEntity(){
    return ProductoSanitarioEntity(uuid, activo, categoriaUid, costo, medida, nombre);
  }

  static ProductoSanitario fromEntity(ProductoSanitarioEntity entity){
    return ProductoSanitario(
      uuid: entity.uuid,
      medida: entity.medida,
      categoriaUid: entity.categoriaUid,
      costo: entity.costo,
      activo: entity.activo,
      nombre: entity.nombre
    );
  }


}
