import 'package:firebase_repository/src/entities/entities.dart';
import 'package:flutter/cupertino.dart';

@immutable
class Raza {
  final String uuid;
  final String nombre;

  Raza({this.uuid, this.nombre});

  Raza copyWith({String uuid, String nombre}) {
    return Raza(
      uuid: uuid ?? this.uuid,
      nombre: nombre ?? this.nombre
    );
  }

  @override
  String toString() {
    return 'Raza{uuid: $uuid, nombre: $nombre}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
          other is Raza &&
              runtimeType == other.runtimeType &&
              uuid == other.uuid &&
              nombre == other.nombre;

  @override
  int get hashCode =>
      uuid.hashCode ^
      nombre.hashCode;

  RazaEntity toEntity(){
    return RazaEntity(uuid, nombre);
  }

  static Raza fromEntity(RazaEntity entity){
    return Raza(
      uuid: entity.uuid,
      nombre: entity.nombre
    );
  }


}
