import 'package:firebase_repository/src/entities/tercero_entity.dart';
import 'package:meta/meta.dart';

@immutable
class Tercero {
  final String uuid;
  final String contacto;
  final String nombre;
  final String cuig;
  final bool activo;
  final List<dynamic> campos;

  Tercero(
      {this.uuid,
      this.contacto,
      this.nombre,
      this.cuig,
      this.activo,
      this.campos});

  @override
  String toString() {
    return 'Tercero{uuid: $uuid, contacto: $contacto, nombre: $nombre, cuig: $cuig, activo: $activo, campos: $campos}';
  }

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Tercero &&
          runtimeType == other.runtimeType &&
          uuid == other.uuid &&
          contacto == other.contacto &&
          nombre == other.nombre &&
          cuig == other.cuig &&
          activo == other.activo &&
          campos == other.campos;

  @override
  int get hashCode =>
      uuid.hashCode ^
      contacto.hashCode ^
      nombre.hashCode ^
      cuig.hashCode ^
      activo.hashCode ^
      campos.hashCode;

  Tercero copyWith(String uuid, String contacto, String nombre, String cuig,
      bool activo, List<Map<String, Object>> campos) {
    return Tercero(
        nombre: nombre ?? this.nombre,
        uuid: uuid ?? this.uuid,
        activo: activo ?? this.activo,
        campos: campos ?? this.campos,
        contacto: contacto ?? this.contacto,
        cuig: cuig ?? this.cuig);
  }

  TerceroEntity toEntity() {
    return TerceroEntity(uuid, contacto, nombre, cuig, activo, campos);
  }

  static Tercero fromEntity(TerceroEntity entity) {
    return Tercero(
        cuig: entity.cuig,
        contacto: entity.contacto,
        campos: entity.campos,
        activo: entity.activo,
        uuid: entity.uuid,
        nombre: entity.nombre);
  }
}
